export * from '@douyinfe/semi-json-viewer-core';
import { JsonViewer } from '@douyinfe/semi-json-viewer-core';
import BaseFoundation, { DefaultAdapter } from '../base/foundation';
export interface JsonViewerAdapter<P = Record<string, any>, S = Record<string, any>> extends DefaultAdapter<P, S> {
    getJsonViewerRef: () => HTMLElement;
    onValueChange: (value: string) => void;
    onValueHover: (value: string, el: HTMLElement) => HTMLElement | undefined;
}
declare class JsonViewerFoundation extends BaseFoundation<JsonViewerAdapter> {
    constructor(adapter: JsonViewerAdapter);
    jsonViewer: JsonViewer | null;
    init(): void;
    onValueChange(value: string): void;
    onValueHover(value: string, el: HTMLElement): HTMLElement | undefined;
    search(searchText: string): void;
    prevSearch(): void;
    nextSearch(): void;
    replace(replaceText: string): void;
    replaceAll(replaceText: string): void;
}
export default JsonViewerFoundation;
